.SUBCKT 6F12PP 1 2 3 4 ; P G2 G1 C (Pentode) 28-Feb-2008
+ PARAMS: MU= 71.45 EX= 1.350 KG1= 260.8 KP=7396.95 KC= 4000
+ KVB= 17.9 VCT= 0.00 RGI= 4500k
+ CCG=6.6P CPG1=0.02P CCP=1.9P
RE1 7 0 1G
RE2 8 4 1G
E1 7 0 VALUE={V(2,4)/KP*LOG(1+EXP((1/MU+V(3,4)/V(2,4))*KP))}
G1 1 4 VALUE={(PWR(V(7),EX)+PWRS(V(7),EX))/KG1*1.57*TANH(2*V(1,4)/(KVB*3.14159))}
G2 8 4 VALUE={(PWR(V(7),EX)+PWRS(V(7),EX))/KC*(2.57-1.57*TANH(2*V(1,4)/(KVB*3.14159)))}
E2 8 2 VALUE={0}
RCP 1 4 1G ; FOR CONVERGENCE
C1 3 4 {CCG} ; CATHODE-GRID 1
C2 1 3 {CPG1} ; GRID 1-PLATE
C3 1 4 {CCP} ; CATHODE-PLATE
R1 3 5 {RGI} ; FOR GRID CURRENT
D3 5 4 DX ; FOR GRID CURRENT
.MODEL DX D(IS=1N RS=1 CJO=10PF TT=1N)
.ENDS

.SUBCKT 6F12PT p g k ; A G C	(Triode)
* library format: LTSpice 15-Oct-2015
+params: Ip=8e-3 Vg=-1.4 Vp=200 Mu=100 Rgk=1e9 Cgk=4.6e-12 Cgp=1.6e-12 Cpk=0.26e-12
gp   p k value = {Ip/pwr((Mu*Vg+Vp),1.5)*pwr(uramp(v(p,k)+Mu*v(g,k)),1.5)}
r1   g x {Rgk}
d1   x k dX
c1   g k {Cgk}
c2   g p {Cgp}
c3   p k {Cpk}
.ends

.subckt 6F12PG2 a g k
* library format: LTSpice 02-Mar-2013
* leave grid open !!! represents IG2 only !
+params: Rgk=100e6 Cak=3e-15
GP   A K  VALUE={10E-7*(PWR(V(A,K)+0.2,1.5)+PWRS(V(A,K)+0.2,1.5))/2}
r1   g k {Rgk}
c1   a k {Cak}
.ends


.SUBCKT 6F12P-T 1 2 3 ; P G C (Triode)
+ PARAMS: MU=112.5 EX= 1.66 KG1= 94 KP=760
+ KVB=12100.0 VCT= 0.00 RGI=4500k
+ CCG=4.6P CGP=1.6P CCP=0.26P
E1 7 0 VALUE={V(1,3)/KP*LN(1+EXP(KP*(1/MU+(V(2,3)+VCT)/SQRT(KVB+V(1,3)*V(1,3)))))}
RE1 7 0 1G
G1 1 3 VALUE={(PWR(V(7),EX)+PWRS(V(7),EX))/KG1}
RCP 1 3 1G ; TO AVOID FLOATING NODES IN MU-FOLLOWER
C1 2 3 {CCG} ; CATHODE-GRID;
C2 2 1 {CGP} ; GRID-PLATE;
C3 1 3 {CCP} ; CATHODE-PLATE;
D3 5 3 DX ; FOR GRID CURRENT
R1 2 5 {RGI} ; FOR GRID CURRENT
.MODEL DX D(IS=1N RS=1 CJO=10PF TT=1N)
.ENDS


.SUBCKT 6F12P-P 1 2 3 4 ; P G2 G1 C (Pentode) 28-Feb-2008
+ PARAMS: MU= 71.45 EX= 1.350 KG1= 260.8 KP=7396.95 KC= 4000
+ KVB= 17.9 VCT= 0.00 RGI= 4500k
+ CCG=6.6P CPG1=0.02P CCP=1.9P
+ KVB2=1.92 KVC=1.6 EX2=0.664 KG2=12
RE1 7 0 1G
RE2 8 4 1G
E1 7 0 VALUE={V(2,4)/KP*LOG(1+EXP((1/MU+V(3,4)/V(2,4))*KP))}
G1 1 4 VALUE={(PWR(V(7),EX)+PWRS(V(7),EX))/KG1*1.57*TANH(2*V(1,4)/(KVB*3.14159))}
* BEGIN screen current
G2 8 4 VALUE={0.1*((PWR(V(7),EX)+PWRS(V(7),EX))/KG1*1.57*TANH(2*V(1,4)/(KVB*3.14159)))}
E2 8 2 VALUE={0} ; Dummy
* End screen current
C1 3 4 {CCG} ; CATHODE-GRID 1
C2 1 3 {CPG1} ; GRID 1-PLATE
C3 1 4 {CCP} ; CATHODE-PLATE
R1 3 5 {RGI} ; FOR GRID CURRENT
D3 5 4 DX ; FOR GRID CURRENT
.MODEL DX D(IS=1N RS=1 CJO=10PF TT=1N)
.ENDS


****************************************************
.SUBCKT 6F12P_T 1 2 3; A G C;
*      Extract V3.000
* Model created: 20-Jul-2016
*
X1 1 2 3 TriodeK MU=109.16 EX=1.623 KG1=  88.2 KP= 474.1 KVB=   44. RGI=2000
+ CCG=0.0P  CGP=0.0P CCP=0.0P  ;
.ENDS

****************************************************
.SUBCKT TriodeK 1 2 3; A G C
*
* NOTE: LOG(x) is base e LOG or natural logarithm.
* For some Spice versions, e.g. MicroCap, this has to be changed to LN(x).
*
E1  7 0 VALUE={V(1,3)/KP*LOG(1+EXP(KP*(1/MU+V(2,3)/SQRT(KVB+V(1,3)*V(1,3)))))}
RE1 7 0 1G
G1  1 3 VALUE={0.5*(PWR(V(7),EX)+PWRS(V(7),EX))/KG1}
RCP 1 3 1G    ; TO AVOID FLOATING NODES IN MU-FOLLOWER
C1  2 3 {CCG}  ; CATHODE-GRID
C2  2 1 {CGP}  ; GRID-PLATE
C3  1 3 {CCP}  ; CATHODE-PLATE
D3  5 3 DX     ; FOR GRID CURRENT
R1  2 5 {RGI}  ; FOR GRID CURRENT
.MODEL DX D(IS=1N RS=1 CJO=10PF TT=1N)
.ENDS TriodeK



****************************************************
.SUBCKT 6F12P_P 1 2 3 4 ; A G2 G1 C;
*      Extract V3.000
* Model created: 20-Jul-2016
*
X1 1 2 3 4 BTetrodeDE  MU= 88.78 EX=1.832 kG1= 124.9 KP=4952.4 kVB =     .0 kG2= 5442.6
+Sc=.40E-01 ap=  .005 w=    29. nu=   .00 lam=     2.3
+ Ookg1mOokG2=.782E-02 Aokg1=.61E-05 alkg1palskg2=.782E-02 be=  .049 als= 37.40 RGI=2000
+ CCG1=0.0P  CCG2 = 0.0p CPG1 = 0.0p  CG1G2 = 0.0p CCP=0.0P  ;
.ENDS

****************************************************
.SUBCKT BTetrodeDE 1 2 3 4; A G2 G1 C
*
* NOTE: LOG(x) is base e LOG or natural logarithm.
* For some Spice versions, e.g. MicroCap, this has to be changed to LN(x).
*
RE1  7 0  1MEG    ; DUMMY SO NODE 7 HAS 2 CONNECTIONS
E1   7 0 VALUE={V(2,4)/KP*LOG(1+EXP(KP*(1/MU+V(3,4)/SQRT(KVB+V(2,4)*V(2,4)))))}
E2   8 0 VALUE = {Ookg1mOokG2 + Aokg1*V(1,4) - alkg1palskg2*Exp(-be*V(1,4)*SQRT(be*V(1,4)))}
E3   9 0 VALUE = {Sc/kG2*V(1,4)*(1+tanh(-ap*(V(1,4)-V(2,4)/lam+w+nu*V(3,4))))}
G1   1 4 VALUE = {0.5*(PWR(V(7),EX)+PWRS(V(7),EX))*(V(8)-V(9))}
G2   2 4 VALUE = {0.5*(PWR(V(7),EX)+PWRS(V(7),EX))/KG2 *(1+als*Exp(-be*V(1,4) * SQRT(be*V(1,4))))}
RCP  1 4  1G      ; FOR CONVERGENCE	A  - C
C1   3 4  {CCG1}   ; CATHODE-GRID 1	C  - G1
C4   2 4  {CCG2}   ; CATHODE-GRID 2	C  - G2
C5   2 3  {CG1G2}   ; GRID 1 -GRID 2	G1  - G2
C2   1 3  {CPG1}  ; GRID 1-PLATE	G1 - A
C3   1 4  {CCP}   ; CATHODE-PLATE	A  - C
R1   3 5  {RGI}   ; FOR GRID CURRENT	G1 - 5
D3   5 4  DX      ; FOR GRID CURRENT	5  - C
.MODEL DX D(IS=1N RS=1 CJO=10PF TT=1N)
.ENDS BTetrodeDE